{***************************************************
* (C) 2010 HannoWare.com                           *
* Make the DanceBot dance with vision!             *
* AppletImage=motor.gif                            *
****************************************************}
CON
 _clkmode        = xtal1 + pll16x
 _xinfreq        = 5_000_000
 #0,RunUpdate,RunFull  
 'Fuzzy Logic Constants 
 #0,FposE,FvelT,FvelE,FtiltT,FtiltE,Fturn,Fmotor 'fuzzy maps
 #0,Rtilt,Rmotor                                 'fuzzy rules
  
  maxti=100000                  'maximum tilt before it bot has fallen
OBJ
  f:     "fuzzy.spin"           'fuzzy logic engine
  m:     "_Motor"               'motor control 
  t:     "_Tilt"                'read tilt of bot
  vp :   "Conduit"              'debug with ViewPort
  qs:    "QuickSample"          'monitor IO port
  freq: "synth"                 'output clock to ADC
  video: "PropCVCapture"        'capture video signal and view in Viewport
  ve:    "PropCVFilter"         'applies vision algorithms to video  
var
  long io,pos,tangle,tvel,trot,rot,rotpos,vel,tilt,turn,motor,posT,velT,tiltT,posE,velE,tiltOff,tiltE,tiltI,bb,bx,by,fuzz[260]
  {lots of interesting variables to follow with viewport:
   io: status of io port
   pos: position of robot as measured by encoder
   tangle: target angle of tilt for bot
   tvel: target velocity 
   trot: amount bot should rotate left/right
   rot: amount of differential steer bot is using now
   rotpos: not used, was for integrating rot
   vel: current velocity
   tilt: current tilt
   turn: current turn amount
   motor: current speed of one motor
   posT: target position
   velT: target velocity
   tiltT: target tilt
   posE: position error
   velE: velocity error
   tiltOff: offset in tilt- calibrated so tilt reads 0 when balanced
   tiltE: tilt error
   tiltI: integrated tilt
   bx:x location of blob
   by:y location of blob
   fuzz: structure for fuzzy logic} 
  long mode,ncnt,oldPos[10],avgPos
  {mode: bot can be updating sensor, or running full- with motor control
   ncnt: next cnt- used to control loop time
   oldPos: average the bot's position
   avgPos: result of averaging}   
  long videoFrame[3000] 'data for captured video
  long rawsee 'raw value from propfilter, contains x,y of blob
pub main|frame[400]
'main loop: start subsystems, then drive bot using vision
  vp.register(qs.sampleINA(@frame,1)) 'sample INA with 1 cog up to 20Mhz
  start1
  vp.register(f.start(@fuzz))
  vp.register(video.start(@videoFrame,video#VIDEO2))  '1 vidoe buffer  
  vp.config(string("var:io(bits=[6acCL,7acDT,5gyrOT,8gyrIn,4m1p,3m1r,27m2p,26m2r,12encA,13encB]),pos,tangle,tvel,trot,rot,rotpos,vel,tilt,turn,motor,Speed,velT,tiltT,posE,velE,tiltOff,tiltE,tiltI,bb,bx,by"))
  vp.config(string("lsa:view=io,timescale=1ms"))
  vp.config(string("video:view=bx"))   
  vp.config(string("dso:view=[bx,by],timescale=1s"))
  vp.config(string("start:dso"))
  vp.share(@pos,@by)
  Freq.Synth("B",24, 10_000_000) ''generate signal for the ADC
  start2
  video.start(@rawsee,video#BLOB)
  tvel~'-2
  trot~
  repeat
    do(1,tvel,trot)
    bx:=rawsee & $ff
    by:=(rawsee>>8) & $ff
    tvel+=by
    trot+=bx
pub restart
  'when bot falls, restart with fresh position
  mode:=runFull
  pos~
  posT~
  rotpos~
  longfill(@oldPos,0,10)
pub start2
  'start motor and tilt cogs
  mode:=runUpdate
  tiltOff:=-360_000
  m.start(@pos)
  t.start
  ncnt:=cnt+8000_000
pub start1 
  'initialize fuzzy logic maps
  f.setVar(@pos)
  f.setMap(FposE,@posE,3000,10000) 
  f.setMap(FvelT,@velT,10,30)
  f.setMap(FvelE,@velE,800,1600)
  f.setMap(FtiltT,@tiltT,30_000,100_000) 
  f.setMap(FtiltE,@tiltE,40_000,120_000)
  f.setMap(Fturn,@turn,40_000,90_000)    
  f.setMap(Fmotor,@motor,2000,7000)
  f.setRule(Rtilt,@posE,@velE,@Mtilt)
  f.setRule(Rmotor,@tiltE,@turn,@Mmotor)
  f.start(@fuzz)  
pub fuzzyControl |t1,t2
  'cascading fuzzy logic pid controller
    posE:=-pos+posT            'posE=positive if on right of target           
    f.fuzzifyA2(posE,FposE)    'A=fuzzy posE
    velT:=-f.defuzzify2(FvelT)  'velT=positive if need to move right
    t1:=f.defuzzify2(FtiltT)
    velE:=vel-velT            'velE=positive if going slower than target
    f.fuzzifyA2(velE,FvelE)    'A=fuzzy velE
    t2:=f.defuzzify2(FtiltT)
    '-t1-t2 is a pi controller, need d which is acceleration, use tilt
    tiltT:=-t1-t2-tilt/6
    f.share(@fuzz)
    tiltE:=tilt-tiltT         'tiltE=positive if tilted right of target
    tiltI+=tiltE/200              'tiltI=positive if tilted right for too long
    tiltI:= (tiltI<# maxTI) #> -maxTI  
    f.fuzzifyA2(tiltE,FtiltE)  'A=fuzzy tiltE
    t1:=f.defuzzify2(Fmotor)
    f.fuzzifyA2(turn,Fturn)    'A=fuzzy turn=positive if turning right
    t2:=f.defuzzify2(Fmotor)
    motor:=-t1-t2/2'+tiltI/1500
pub balance|mpos
  'update readings, then balance using fuzzy logic
    t.update1(80_000) 
    if ||(tiltE)> 500_000 'if can't match tilt, then stop motors
      mode:=runUpdate
    mPos:=pos'-rotPos 'read in pos for this round, adjust for turns
    vel:=(mPos-oldPos[avgPos])
    oldPos[avgPos]:=mPos
    avgPos+=1  'averages velocity by subtracting current position to position(t-10)
    if avgPos > 9
      avgPos~
    tilt:=t.update2(@turn)-tiltOff
    fuzzyControl
    case mode
      runUpdate:
        m.update(0,0)
        if ||(tiltE)<40_000
          restart
      runFull:
        m.update(motor-rot,motor+rot)
        m.update(-motor+rot,-motor-rot)
    waitcnt(nCnt+=400000) 'wait 5msec
    return mode <> runFull    
pub do(n,_vel,_rot) 
  'stays in balance while moving with vel, rotating trot
  repeat n
    posT+=_vel
    rot:=_rot
    if tangle>15000
      tangle-=15000
    elseif tangle<0
      tangle+=15000
    if balance
      return false    
  return true
dat 'Fuzzy Logic Maps
  mtilt byte 0,0,0,1,2
        byte 0,0,1,2,3
        byte 0,1,2,3,4
        byte 1,2,3,4,4
        byte 2,3,4,4,4,  0,0,0 'last 3 are needed to make 28 bytes=7 longs        
 mmotor byte 0,0,0,1,2
        byte 0,0,1,2,3
        byte 0,1,2,3,4
        byte 1,2,3,4,4
        byte 2,3,4,4,4,  0,0,0 'last 3 are needed to make 28 bytes=7 longs                  